<?php
namespace ID3\Blog;

class Admin extends \ID3\Bases\AdminInstance{

    function __construct(){
        parent::__construct(__NAMESPACE__);

        add_action('load-post.php', [$this, 'read_only_content'], 199);

        add_filter('manage_post_posts_columns', [$this, 'manage_post_columns']);
        add_action('manage_post_posts_custom_column', [$this, 'manage_post_column_content'], 10, 2);
    }

    function manage_post_columns($columns) {
        $newColumn = ['reference_id' => __('Remote ID', TDOM)];
        $columns = array_slice($columns,0,2) + $newColumn + array_slice( $columns, 2 );
        return $columns;
        return array_merge($columns, $newColumn);
    }

    function manage_post_column_content($column_key, $post_id) {
        if ($column_key == 'reference_id') {
            $ref_id = get_post_meta($post_id, 'reference_id', true);
            if ($ref_id) {

                echo '<span style="color:red;">'; 
                echo '<i class="fas fa-lock"></i> ';
                echo $ref_id;
                echo '</span>';
            } else {
                echo '';
            }
        }
    }

    function read_only_content() {
        //if ( ! current_user_can('manage_options') ) { // change the cap with the wanted one
            $scr = get_current_screen();
            if($scr->post_type == 'post'){

                $post_id = $_GET['post'];
                $remote_id = get_post_meta($post_id, 'reference_id');

                if($remote_id != null){
                        

                    $supports = ['editor','title','thumbnail','excerpt','trackbacks','custom-fields','comments','revisions','page-attributes','post-formats','elementor','sitepress','wpml'];
                    foreach ($supports as $key) {
                        remove_post_type_support( $scr->post_type, $key );
                    } 
                    $metaboxes = ['icl_div','icl_div_config','submitdiv','categorydiv','tagsdiv-post_tag','pageparentdiv','rocket_post_exclude'];
                    foreach ($metaboxes as $box) {
                        remove_meta_box($box,'post','normal' ); 
                        remove_meta_box($box,'post','side' );
                    }
                    
                    add_action('edit_form_after_editor', [$this, 'print_the_content']);
                    
                }
            }
        //}
    }

    function print_the_content( $post ) {
        echo '<h1>' . $post->post_title . '</h1>';
        echo '<div id="content" style="width=99%;margin:15px 0;padding:1%;border:1px solid #aaa">'; 
        echo apply_filters('the_content', $post->post_content);
        echo '<div><em>Cet article est pris en charge par le plugin ID-3 Blog et ne peux être modifier. Pour suggérer des changements, veuillez contacter votre stratège ou votre administrateur réseau.</em></div>';
        
        echo '<script type="text/javascript"> jQuery(document).ready( () => { Array.from(document.querySelectorAll("#icl_div,#icl_div_config")).forEach( (e) => { e.remove(); }) })</script>';
        echo '</div>';

        echo '<div style="width=99%;margin:15px 0;padding:1%;border:1px solid #aaa;background:#fff;border-left:4px solid #f90;"><em>This article is supported by the ID-3 blog plugin and cannot be changed. To suggest changes, please contact your strategist or network administrator.</em></div>';
      }
    
}

new Admin();
