<?php

namespace ID3\Blog;

class Post{
    static $seo_applied = 0;

    function __construct(){
        
        

    }

    static function register_hooks(){
        $instance = new \ID3\Blog\Post();
        
        add_filter( 'wp_get_attachment_image_src', [$instance, 'replace_attachment_image_src'], 5, 3);
        add_filter( 'wp_get_attachment_url', [$instance, 'replace_attachment_url'], 5, 2);
        
        add_filter('wpseo_image', array($instance, 'seo_image'), 2,1);
        add_filter('wpseo_opengraph_image', array($instance, 'og_seo_image'), 2,1);
        add_filter('wpseo_twitter_image', array($instance, 'twitter_seo_image'), 2,1);
        add_filter('wpseo_add_opengraph_images', [$instance, 'add_opengraph_images'],10,1);

        add_filter('id3-blog/post-image', [$instance,'get_random_image']);

        add_filter('the_excerpt_rss', [$instance, 'rss_post_thumbnail']);
        add_filter('the_content_feed', [$instance, 'rss_post_thumbnail']);
    }

    function rss_post_thumbnail($content) {
        global $post;
        if(has_post_thumbnail($post->ID)) {
            $content = '<p>' . get_the_post_thumbnail($post->ID) .
            '</p>' . get_the_content();
        }
        return $content;
    }
        
    function add_opengraph_images($image_container){
        if(!$image_container->has_images()){
            $url = get_the_post_thumbnail_url();
            $image_container->add_image_by_url($url);
        }
        return $image_container;
    }

    // Replace image source in article list (elementor)
    function replace_attachment_image_src($image, $att_id, $size){
        if(apply_filters('id3-blog/allow-image-src-filtering', true) === false) return $image;
        if(is_array($image) && count($image) == 0) return;
        if($image === false) return;
        
        $alt_url = $this->get_image_from_meta($att_id);

        if($alt_url != null){
            if(strpos($alt_url, "http")!==false){
                $image[0] = $alt_url;
            }
        }

        return $image;
    }
    function get_image_from_meta($att_id){
        if(!$att_id || $att_id == 0) return null;
        $result = get_post_meta($att_id,'_wp_attached_file', true);
        if(strlen($result) == 0) return null;
        return $result;
    }

    function get_random_image($image){
        $randomImage = 'https://picsum.photos/480/640/?blur=4&grayscale';
        if($image == null) return $randomImage ;
        if($image == '') return $randomImage;
        
        return $image;
    }

    // Replace image url (wordpress articles page)
    function replace_attachment_url($att_url, $att_id){
        if(apply_filters('id3-blog/allow-image-src-filtering', true) === false) return $att_url;

        $url = get_post_meta($att_id,'_wp_attached_file', true);
        
        if($att_url != $url){
            if(strpos($url, "http")!==false){
                return $url;
            }
        }
        
        
        return $att_url;
    }

    public function seo_image($image_path=''){
        if($image_path == ''){
            //$post_id = get_the_ID();
            return \get_the_post_thumbnail_url();

        }
        else{
            //var_dump($image_path);
        }
        
        return $image_path;
    }

    public function og_seo_image($image_path=''){
        //\ID3\debug($image_path);
        return $this->seo_image($image_path);
    }

    public function twitter_seo_image($image_path=''){
        return $this->seo_image($image_path);
    }

}