id3Plugin
.controller('categoryFilterCtrl', function($scope, $rootScope, $q, $timeout, $id3Lists, $id3Rest, $id3UI){
    $scope.categoryList = [];
    $scope.subscriptions = [];
    $scope.exceptions = [];

    $scope.dialogOptions.actions = [
            {label: 'OK', primary: true, 
                action: function(){ 
                    $scope.settings.category_subscriptions = $scope.subscriptions;
                    $scope.settings.category_exceptions = $scope.exceptions;
                    console.log('categoryFilterCtrl/OK', $scope.settings);
                    $scope.closeAndReturn($scope.settings); 
                } 
            },
            {label: 'Cancel', 
                action: function(){ 
                    console.log('categoryFilterCtrl/Cancel');
                    $scope.cancel(); 
                } 
            }
        ];

    $scope.init = function($params){
        $scope.model = $params.model;
        $scope.type = $params.type;
        $scope.settings = $params.settings;

        console.log($scope.settings);

        $scope.fetchData().then( _ => {
            $scope.prepareModels();
        })        
        console.log('categoryFilterCtrl/init', $params,  $scope.categoryList);
    }

    $scope.fetchData = function(){
        
        return $scope.fetchSupportedLanguages()
            .then( $languages => {
                if($languages.includes('fr')){
                    $languages.splice($languages.indexOf('fr'),1);
                    $languages.unshift('fr');
                }
                $scope.supportedLanguages = $languages;
                
                return $q.all(
                    $scope.supportedLanguages.map( lang => $scope.fetchSourceCategories(lang))
                )
                .then( categoryByLang => {
                    $scope.supportedLanguages.forEach( (lang,index) => {
                        $id3Lists.register('blogCategories' + lang, categoryByLang[index]);
                        $scope.categoryList[lang] = angular.copy($id3Lists.getTree('blogCategories' + lang));
                    })
                })
                // $scope.fetchSourceCategories().then( $list => {
                //     $id3Lists.register('blogCategories', $scope.categoryList);
                //     $scope.categoryList = angular.copy($id3Lists.getTree('blogCategories'));
        
                // })
                
            })
            .then ( _ => {
                console.log($scope.categoryList);
            })
    }

    $scope.prepareModels = function(){

        $scope.subscriptions = $scope.settings['category_subscriptions'];
        $scope.exceptions = $scope.settings['category_exceptions'];
        if(id3IsNullOrEmpty($scope.subscriptions)){
            $scope.subscriptions = $scope.supportedLanguages.reduce( (r,c) => {
                r[c] = {
                    all: true,
                    list: []
                }
                return r
            }, {})
        }
        if(typeof $scope.subscriptions.all == 'boolean'){
            // $scope.subscriptions = {
            //     fr: {
            //         all: $scope.subscriptions.all,
            //         list:$scope.subscriptions.list
            //     }
            // }
            $scope.subscriptions = $scope.supportedLanguages.reduce( (r,c) => {
                r[c] = {
                    all: $scope.subscriptions.all,
                    list: $scope.subscriptions.list
                }
                return r
            }, {})
        }

        if(id3IsNullOrEmpty($scope.exceptions)){
            $scope.exceptions = $scope.supportedLanguages.reduce( (r,c) => {
                r[c] = {
                    all: false,
                    list: []
                }
                return r
            }, {})            
        }

        // $scope.prepareModel($scope.subscriptions);
        // $scope.prepareModel($scope.exclusions);
    }

    $scope.isChecked = function(item, list){
        if(id3IsNullOrEmpty(list)) return false;

        return list.list.find( $e => $e.key == item.key) != null;
    }

    $scope.select = function(item, list){
        const index = list.list.findIndex( $e => $e.key == item.key);

        if(index >= 0){
            list.list.splice(index,1);
            return;
        }

        list.list.push(angular.copy(item));
    }

    $scope.prepareModel = function($model){
        // const lSelection = $model.list.map($e => $e.key);
        // console.log('init', lSelection);

        // Object.keys($scope.categoryList[])
        // $scope.categoryList.reduce( ($acc, $cur) =>{
        //     const lCur = $cur;
        //     //delete lCur.children;
        //     $acc.push(...[lCur,...$cur.children])
        //     return $acc;
        // },[])
        // .forEach($e => {
        //     //console.log('category/item', $e);

        //     if(lSelection.includes($e.key)){
        //         $e._selected = true;
        //     }
        //     else{
        //         $e._selected = false;
        //     }
        // })
    }

    $scope.toggleSelections = function($allIsOn){
        if($allIsOn){
            $scope.model.list = [];
            const lCategories = $scope.categoryList
                        .reduce( ($acc, $cur) =>{
                            const lCur = $cur;
                            //delete lCur.children;
                            $acc.push(...[lCur,...$cur.children])
                            return $acc;
                        },[]);
            lCategories.forEach($c => {
                delete $c._selected;
            });
        }
    }

    $scope.updateModel = function(){
        $timeout(_ => {
            const lCategories = $scope.categoryList
                        .reduce( ($acc, $cur) =>{
                            const lCur = $cur;
                            //delete lCur.children;
                            $acc.push(...[lCur,...$cur.children])
                            return $acc;
                        },[]);

            const lSelection = lCategories
                    .filter($c => $c._selected == true);

            console.log('updateModel', lSelection, lCategories);

            $scope.model.list = lSelection.map($c => {
                return {
                    key: $c.key,
                    label: $c.label
                };
            })
        });
        
    }

    $scope.getSourceEntrypoint = function(){
        if( $scope.settings.source == null){
            console.log('Source is null');
            return null;
        }
        if( $scope.settings.source == 'custom' && id3IsNullOrEmpty($scope.settings.source_custom) ) {
            return null;
        }

        const sourcePath = $scope.settings.source == 'custom' ? $scope.settings.source_custom : 'https://' + $scope.settings.source;
        return sourcePath;
    }

    $scope.fetchSupportedLanguages = function(){
        const sourcePath = $scope.getSourceEntrypoint();
        if(sourcePath == null){
            $q.resolve([]);
        }

        const lEndpoint = `${sourcePath}/wp-json/id3-dlp/`;
        return $q( ($resolve) => {
            $id3Rest.from(lEndpoint).get('supported-languages').then(
                $response => {
                    $resolve($response);
                }
            )
            .catch( _ => {
                return $resolve(['fr'])
            })
        })
        return 
    }
    $scope.fetchSourceCategories = function(lang){
        const sourcePath = $scope.getSourceEntrypoint();
        if(sourcePath == null){
            $q.resolve([]);
        }

        const lEndpoint = `${sourcePath}/wp-json/id3-dlp/`;
        return $q( ($resolve, $reject) => {
            $id3Rest.from(lEndpoint).get('categories',{locale: lang})
            .then( 
                $response => {
                    $resolve($response.map($e => {
                        return {
                            key: $e.term_id,
                            label: $e.name,
                            lang: $e.lang,
                            article_count: $e.count,
                            parent: $e.parent
                        }
                    }));
                },
                $error => {
                    $resolve([]);
                }
            );
        });
    } 

    $scope.previewArticleList = function(lang){
        const dialogParams = {
            lang: lang
        };

        const sourcePath = $scope.getSourceEntrypoint();
        if(sourcePath == null){
            $q.resolve([]);
        }

        dialogParams.endpoint = `${sourcePath}/wp-json/id3-dlp/`;
        dialogParams.subscriptions = {
            type: "subscriptions",
            all: $scope.subscriptions[lang].all,
            list: $scope.subscriptions[lang].list.map(e => e.key)
        }
        dialogParams.exceptions = {
            type: "exceptions",
            all: $scope.exceptions[lang].all,
            list: $scope.exceptions[lang].list.map(e => e.key)
        }


        $id3UI.dialog('filtered-article-preview', dialogParams);
    }

});

id3Plugin
.controller('filteredArticlePreviewCtrl', function($scope, $rootScope, $q, $id3Rest){
    $scope.context ={
        fetching: false
    }
    $scope.init = function($params){
        $scope.fetchArticles($params).then($list => {
            $scope.list = $list.articles;
        })
    }

    $scope.fetchArticles = function(options){
        $scope.context.fetching = true;
        const params = {
            slave_id: window.location.host,
            limit_date: '2020-01-01',
            filters:[
                options.subscriptions,
                options.exceptions
            ],
            sync_mode: 'full',
            locale: options.lang
        }
        return $q( ($resolve) => {
            $id3Rest.from(options.endpoint).post('salvage', params).then(
                $response => {
                    $resolve($response);
                    $scope.context.fetching = false;
                }
            )
            .catch( _ => {
                return $resolve(['fr'])
            })
        })
    }
})

id3Plugin
.controller('synchronisationCtrl', function($scope, $rootScope,$q, $timeout,$id3Rest, $id3Lists){
    $scope.actions = {
        'Cancel' : function(){
            $scope.cancelProcess().then(_ => {
                $scope.close();
            });
        }
    }

    $scope.processPromise = null;

    $scope.state = {
        message: '',
        current_index: 0,
        total_operation: 0
    }

    $scope.init = function($params){
        $scope.settings = $params;

        $scope.state.message = 'Initializing';

        $scope.process();
    }

    $scope.cancelProcess = function(){
        return $q( ($resolve,$reject) => {
            $scope.processPromise.reject();  
            $resolve();
        })
    }

    $scope.process = function(){

        $q.all([
            $id3Rest
        ]).then(_ => {
            $scope.close();
        })
    }

})
