/**
 * 
 * Wizards controller file
 * 
 */

id3Plugin
.controller('firstUseWizardCtrl', function($scope, $rootScope,$id3Lists){
    $scope.model = {
        source: null
    }
    $scope.sources = $id3Lists.get('blogSources');

    $scope.init = function($params){
        $scope.registerPages([
            { key: 'sources',             path: 'first-use/sources' },
        ]);

        $scope.registerValidation('sources', _ => $scope.validatePage('sources'));
        $scope.registerAction('buildResult', $scope.buildResult);

    }

    $scope.validatePage = function($pageName){
        
        const lValidationHandlers = {
            'sources': _ => { 
                return $scope.model.sources != null
            }
        }

        if(lValidationHandlers[$pageName] != undefined){
            return lValidationHandlers[$pageName]();
        }

        return true;
    }

    $scope.buildResult = function(){
        const lResult = $scope.model;
        return lResult;
    }

});

id3Plugin
.controller('synchronisationWizardCtrl', function($scope, $timeout, $rootScope, $id3Rest, $id3Lists){
    $scope.model = {
        type: 'incremental',
        limit_date: null,
    }

    $scope.timelapse = 99999;

    $scope.ageBoundaries = {}
    // $scope.minDate = moment('2021-01-01').toDate();
    // $scope.maxDate = moment().toDate();

    $scope.init = function($params){
        //$scope.ageBoundaries.min = moment().startOf('year').toDate();
        $scope.ageBoundaries.max = moment().toDate();       

        $scope.settings = $params;
        
        $scope.setOptions({
            showNext: false,
            completeLabel: 'Synchronization completed'
        });

        if($scope.settings.last_sync != null){
            let lLastSync = moment($scope.settings.last_sync);
            if(lLastSync.isBefore('2020-01-01')){
                lLastSync = moment('2020-01-01');
            }
            $scope.model.limit_date =lLastSync.toDate();
        }

        $scope.registerPages([
            { key: 'type',             path: 'sync/type-choice' },
            { key: 'age',              path: 'sync/age-limit' },
            { key: 'process',          path: 'sync/process' }
        ]);
    
        $scope.$on('id3Wizard/pageEnter', function($event, $page){
            
            if($page.key == 'process'){
                $scope.setOptions({showNavigation: false});
                $scope.startSync();
            }
        })
    }

    $scope.selectType = function($type){
        $scope.model.type = $type;
        $scope.nextStep();
    }


    $scope.selectDateLimit = function(){
        console.log('selectDateLimit', $scope.$wizard.currentIndex);
        if($scope.$wizard.currentIndex == 1){
            $scope.nextStep();
        }
    }
    $scope.startSync = function(){
        $scope.timelapse = 999999;
        const lTimestamp = Date.now();
        $id3Rest.call('blog/sync/start', {
            date: moment($scope.model.limit_date).format('YYYY-MM-DD'),
            method: $scope.model.type
        }, {
            backburner_timeout:-1   // turn off backburner 
        }).then( _ => {
            $timeout(_ => {  
                $scope.timelapse = Date.now() - lTimestamp;
                console.log('update lasted', $scope.timelapse);

                if($scope.timelapse < 1000){
                    $timeout(_ => {
                        $scope.exitWizard();
                    },1000);
                }
                else{
                    $scope.exitWizard();
                }
                
            })
        })
    }
})